<template>
  <div class="component-upload-image">
    <el-upload 
      ref="imageUploadRef" 
      :action="uploadImgUrl" 
      :before-upload="handleBeforeUpload"
      :class="{ hide: fileList.length >= limit }"
      :file-list="fileList" 
      :headers="headers" 
      :limit="limit" 
      :multiple="multiple"
      :on-error="handleUploadError" 
      :on-exceed="handleExceed" 
      :on-preview="handlePictureCardPreview" 
      :on-remove="handleDelete"
      :on-success="handleUploadSuccess" 
      :show-file-list="true"
      list-type="picture-card"
    >
      <el-icon><Plus /></el-icon>
    </el-upload>

    <!-- 上传提示 -->
    <div v-if="showTip" class="el-upload__tip">
      请上传
      <template v-if="fileSize">
        大小不超过
        <b style="color: #f56c6c">{{ fileSize }}MB</b>
      </template>
      <template v-if="fileType">
        格式为
        <b style="color: #f56c6c">{{ fileType.join('/') }}</b>
      </template>
      的文件
    </div>

    <el-dialog 
      title="预览" 
      v-model="dialogVisible" 
      append-to-body
      width="800"
    >
      <img :src="dialogImageUrl" style="display: block; max-width: 100%; margin: 0 auto"/>
    </el-dialog>
  </div>
</template>

<script setup>
import { ref, computed, watch } from 'vue'
import { Plus } from '@element-plus/icons-vue'
import { getAccessToken } from '@/utils/auth'
import { ElMessage, ElLoading } from 'element-plus'


// 定义组件名称
defineOptions({
  name: 'ImageUpload'
})


// 定义props
const props = defineProps({
  value: [String, Object, Array],
  // 图片数量限制
  limit: {
    type: Number,
    default: 5,
  },
  // 大小限制(MB)
  fileSize: {
    type: Number,
    default: 5,
  },
  // 文件类型, 例如['png', 'jpg', 'jpeg']
  fileType: {
    type: Array,
    default: () => ['png', 'jpg', 'jpeg'],
  },
  // 是否显示提示
  isShowTip: {
    type: Boolean,
    default: true,
  },
  // 是否支持多选文件
  multiple: {
    type: Boolean,
    default: true,
  },
})

// 定义emits
const emit = defineEmits(['input'])

// Refs
const imageUploadRef = ref(null)

// 数据定义
const number = ref(0)
const uploadList = ref([])
const dialogImageUrl = ref('')
const dialogVisible = ref(false)
const hideUpload = ref(false)
const baseUrl = import.meta.env.VITE_BASE_URL
const uploadImgUrl = import.meta.env.VITE_BASE_URL + '/common/upload' // 上传的图片服务器地址
const headers = {
  Authorization: 'Bearer ' + getAccessToken(),
}
const fileList = ref([])

// 计算属性
// 是否显示提示
const showTip = computed(() => {
  return props.isShowTip && (props.fileType || props.fileSize)
})

// Watchers
watch(
  () => props.value,
  (val) => {
    if (val) {
      // 首先将值转为数组
      const list = Array.isArray(val) ? val : props.value.split(',')
      // 然后将数组转为对象数组
      fileList.value = list.map((item) => {
        if (typeof item === 'string') {
          if (item.indexOf(baseUrl) === -1) {
            item = { name: baseUrl + item, url: baseUrl + item }
          } else {
            item = { name: item, url: item }
          }
        }
        return item
      })
    } else {
      fileList.value = []
      return []
    }
  },
  {
    deep: true,
    immediate: true,
  }
)

// 方法定义
// 上传前loading加载
const handleBeforeUpload = (file) => {
  console.log('handleBeforeUpload>>>>>>>>>>>>>>>>>>>', file)
  let isImg = false
  if (props.fileType.length) {
    let fileExtension = ''
    if (file.name.lastIndexOf('.') > -1) {
      fileExtension = file.name.slice(file.name.lastIndexOf('.') + 1)
    }
    isImg = props.fileType.some((type) => {
      if (file.type.indexOf(type) > -1) return true
      if (fileExtension && fileExtension.indexOf(type) > -1) return true
      return false
    })
  } else {
    isImg = file.type.indexOf('image') > -1
  }

  if (!isImg) {
    ElMessage.error(
      '文件格式不正确, 请上传' + 
      `${props.fileType.join('/')}` + 
     '格式文件'
    )
    return false
  }
  if (props.fileSize) {
    const isLt = file.size / 1024 / 1024 < props.fileSize
    if (!isLt) {
      ElMessage.error('上传头像图片大小不能超过' + `${props.fileSize} MB!`)
      return false
    }
  }

  number.value++
}

// 文件个数超出
const handleExceed = () => {
  ElMessage.error(
    '上传文件数量不能超过' + 
    `${props.limit}` + 
    '个'
  )
}

// 上传成功回调
const handleUploadSuccess = (res, file) => {
  if (res.code === 200) {
    uploadList.value.push({ name: res.fileName, url: res.fileName })
    uploadedSuccessfully()
  } else {
    number.value--
    // ElMessage.closeLoading()
    ElMessage.error(res.msg)
    imageUploadRef.value.handleRemove(file)
    uploadedSuccessfully()
  }
}

// 删除图片
const handleDelete = (file) => {
  const findex = fileList.value.map((f) => f.name).indexOf(file.name)
  if (findex > -1) {
    fileList.value.splice(findex, 1)
    emit('input', listToString(fileList.value))
  }
}

// 上传失败
const handleUploadError = () => {
  ElMessage.error('上传图片失败，请重试')
  // ElMessage.closeLoading()
}

// 上传结束处理
const uploadedSuccessfully = () => {
  if (number.value > 0 && uploadList.value.length === number.value) {
    fileList.value = fileList.value.concat(uploadList.value)
    uploadList.value = []
    number.value = 0
    emit('input', listToString(fileList.value))
    // ElMessage.closeLoading()
  }
}

// 预览
const handlePictureCardPreview = (file) => {
  dialogImageUrl.value = file.url
  dialogVisible.value = true
}

// 对象转成指定字符串分隔
const listToString = (list, separator) => {
  let strs = ''
  separator = separator || ','
  for (let i in list) {
    if (list[i].url) {
      strs += list[i].url.replace(baseUrl, '') + separator
    }
  }
  return strs != '' ? strs.substr(0, strs.length - 1) : ''
}
</script>

<style scoped lang="scss">
// .el-upload--picture-card 控制加号部分
::v-deep.hide .el-upload--picture-card {
  display: none;
}

// 去掉动画效果
::v-deep .el-list-enter-active,
::v-deep .el-list-leave-active {
  transition: all 0s;
}

::v-deep .el-list-enter,
.el-list-leave-active {
  opacity: 0;
  transform: translateY(0);
}
</style>